## zfsutils 10.1~svn272500

=== lib/libmd/Makefile ===
# $FreeBSD: releng/10.1/lib/libmd/Makefile 234746 2012-04-28 02:48:51Z obrien $

LIB=	md
SHLIB_MAJOR= 6
SHLIBDIR?= /lib
SRCS=	md4c.c md5c.c md4hl.c md5hl.c \
	rmd160c.c rmd160hl.c \
	sha0c.c sha0hl.c sha1c.c sha1hl.c \
	sha256c.c sha256hl.c \
	sha512c.c sha512hl.c
INCS=	md4.h md5.h ripemd.h sha.h sha256.h sha512.h

WARNS?=	0

MAN+=	md4.3 md5.3 ripemd.3 sha.3 sha256.3 sha512.3
MLINKS+=md4.3 MD4Init.3 md4.3 MD4Update.3 md4.3 MD4Final.3
MLINKS+=md4.3 MD4End.3  md4.3 MD4File.3   md4.3 MD4FileChunk.3
MLINKS+=md4.3 MD4Data.3
MLINKS+=md5.3 MD5Init.3 md5.3 MD5Update.3 md5.3 MD5Final.3
MLINKS+=md5.3 MD5End.3  md5.3 MD5File.3   md5.3 MD5FileChunk.3
MLINKS+=md5.3 MD5Data.3
MLINKS+=ripemd.3 RIPEMD160_Init.3  ripemd.3 RIPEMD160_Update.3
MLINKS+=ripemd.3 RIPEMD160_Final.3 ripemd.3 RIPEMD160_Data.3
MLINKS+=ripemd.3 RIPEMD160_End.3   ripemd.3 RIPEMD160_File.3
MLINKS+=ripemd.3 RIPEMD160_FileChunk.3
MLINKS+=sha.3 SHA_Init.3  sha.3 SHA_Update.3  sha.3 SHA_Final.3
MLINKS+=sha.3 SHA_End.3   sha.3 SHA_File.3    sha.3 SHA_FileChunk.3
MLINKS+=sha.3 SHA_Data.3
MLINKS+=sha.3 SHA1_Init.3 sha.3 SHA1_Update.3 sha.3 SHA1_Final.3
MLINKS+=sha.3 SHA1_End.3  sha.3 SHA1_File.3   sha.3 SHA1_FileChunk.3
MLINKS+=sha.3 SHA1_Data.3
MLINKS+=sha256.3 SHA256_Init.3  sha256.3 SHA256_Update.3
MLINKS+=sha256.3 SHA256_Final.3 sha256.3 SHA256_End.3
MLINKS+=sha256.3 SHA256_File.3  sha256.3 SHA256_FileChunk.3
MLINKS+=sha256.3 SHA256_Data.3
MLINKS+=sha512.3 SHA512_Init.3  sha512.3 SHA512_Update.3
MLINKS+=sha512.3 SHA512_Final.3 sha512.3 SHA512_End.3
MLINKS+=sha512.3 SHA512_File.3  sha512.3 SHA512_FileChunk.3
MLINKS+=sha512.3 SHA512_Data.3
CLEANFILES+=	md[245]hl.c md[245].ref md[245].3 mddriver \
		rmd160.ref rmd160hl.c rmddriver \
		sha0.ref sha0hl.c sha1.ref sha1hl.c shadriver \
		sha256.ref sha256hl.c sha512.ref sha512hl.c

CFLAGS+= -I${.CURDIR}
.PATH: ${.CURDIR}/${MACHINE_ARCH}

.if exists(${MACHINE_ARCH}/sha.S)
SRCS+=	sha.S
CFLAGS+= -DSHA1_ASM
.endif
.if exists(${MACHINE_ARCH}/rmd160.S)
SRCS+=	rmd160.S
CFLAGS+= -DRMD160_ASM
.endif
.if exists(${MACHINE_ARCH}/sha.S) || exists(${MACHINE_ARCH}/rmd160.S)
ACFLAGS+= -DELF -Wa,--noexecstack
.endif

md4hl.c: mdXhl.c
	(echo '#define LENGTH 16'; \
		sed -e 's/mdX/md4/g' -e 's/MDX/MD4/g' ${.ALLSRC}) > ${.TARGET}

md5hl.c: mdXhl.c
	(echo '#define LENGTH 16'; \
		sed -e 's/mdX/md5/g' -e 's/MDX/MD5/g' ${.ALLSRC}) > ${.TARGET}

sha0hl.c: mdXhl.c
	(echo '#define LENGTH 20'; \
		sed -e 's/mdX/sha/g' -e 's/MDX/SHA_/g' -e 's/SHA__/SHA_/g' \
		${.ALLSRC}) > ${.TARGET}

sha1hl.c: mdXhl.c
	(echo '#define LENGTH 20'; \
		sed -e 's/mdX/sha/g' -e 's/MDX/SHA1_/g' -e 's/SHA1__/SHA1_/g' \
		${.ALLSRC}) > ${.TARGET}

sha256hl.c: mdXhl.c
	(echo '#define LENGTH 32'; \
		sed -e 's/mdX/sha256/g' -e 's/MDX/SHA256_/g'	\
			-e  's/SHA256__/SHA256_/g' \
		${.ALLSRC}) > ${.TARGET}

sha512hl.c: mdXhl.c
	(echo '#define LENGTH 64'; \
		sed -e 's/mdX/sha512/g' -e 's/MDX/SHA512_/g'	\
			-e  's/SHA512__/SHA512_/g' \
		${.ALLSRC}) > ${.TARGET}

rmd160hl.c: mdXhl.c
	(echo '#define LENGTH 20'; \
		sed -e 's/mdX/ripemd/g' -e 's/MDX/RIPEMD160_/g' \
			-e 's/RIPEMD160__/RIPEMD160_/g' \
			${.ALLSRC}) > ${.TARGET}

.for i in 2 4 5
md${i}.3: ${.CURDIR}/mdX.3
	sed -e "s/mdX/md${i}/g" -e "s/MDX/MD${i}/g" ${.ALLSRC} > ${.TARGET}
	cat ${.CURDIR}/md${i}.copyright >> ${.TARGET}
.endfor

md4.ref:
	echo 'MD4 test suite:' > ${.TARGET}
	@echo 'MD4 ("") = 31d6cfe0d16ae931b73c59d7e0c089c0' >> ${.TARGET}
	@echo 'MD4 ("a") = bde52cb31de33e46245e05fbdbd6fb24' >> ${.TARGET}
	@echo 'MD4 ("abc") = a448017aaf21d8525fc10ae87aa6729d' >> ${.TARGET}
	@echo 'MD4 ("message digest") = d9130a8164549fe818874806e1c7014b' >> ${.TARGET}
	@echo 'MD4 ("abcdefghijklmnopqrstuvwxyz") = d79e1c308aa5bbcdeea8ed63df412da9' >> ${.TARGET}
	@echo 'MD4 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'043f8582f241db351ce627e153e7f0e4' >> ${.TARGET}
	@echo 'MD4 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'e33b4ddc9c38f2199c3e7b164fcc0536' >> ${.TARGET}

md5.ref:
	echo 'MD5 test suite:' > ${.TARGET}
	@echo 'MD5 ("") = d41d8cd98f00b204e9800998ecf8427e' >> ${.TARGET}
	@echo 'MD5 ("a") = 0cc175b9c0f1b6a831c399e269772661' >> ${.TARGET}
	@echo 'MD5 ("abc") = 900150983cd24fb0d6963f7d28e17f72' >> ${.TARGET}
	@echo 'MD5 ("message digest") = f96b697d7cb7938d525a2f31aaf161d0' >> ${.TARGET}
	@echo 'MD5 ("abcdefghijklmnopqrstuvwxyz") = c3fcd3d76192e4007dfb496cca67e13b' >> ${.TARGET}
	@echo 'MD5 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") = d174ab98d277d9f5a5611c2c9f419d9f' >> ${.TARGET}
	@echo 'MD5 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") = 57edf4a22be3c955ac49da2e2107b67a' >> ${.TARGET}

sha0.ref:
	echo 'SHA-0 test suite:' > ${.TARGET}
	@echo 'SHA-0 ("") = f96cea198ad1dd5617ac084a3d92c6107708c0ef' >> ${.TARGET}
	@echo 'SHA-0 ("abc") = 0164b8a914cd2a5e74c4f7ff082c4d97f1edf880' >> ${.TARGET}
	@echo 'SHA-0 ("message digest") =' \
		'c1b0f222d150ebb9aa36a40cafdc8bcbed830b14' >> ${.TARGET}
	@echo 'SHA-0 ("abcdefghijklmnopqrstuvwxyz") =' \
		'b40ce07a430cfd3c033039b9fe9afec95dc1bdcd' >> ${.TARGET}
	@echo 'SHA-0 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'79e966f7a3a990df33e40e3d7f8f18d2caebadfa' >> ${.TARGET}
	@echo 'SHA-0 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'4aa29d14d171522ece47bee8957e35a41f3e9cff' >> ${.TARGET}

sha1.ref:
	echo 'SHA-1 test suite:' > ${.TARGET}
	@echo 'SHA-1 ("") = da39a3ee5e6b4b0d3255bfef95601890afd80709' >> ${.TARGET}
	@echo 'SHA-1 ("abc") = a9993e364706816aba3e25717850c26c9cd0d89d' >> ${.TARGET}
	@echo 'SHA-1 ("message digest") =' \
		'c12252ceda8be8994d5fa0290a47231c1d16aae3' >> ${.TARGET}
	@echo 'SHA-1 ("abcdefghijklmnopqrstuvwxyz") =' \
		'32d10c7b8cf96570ca04ce37f2a19d84240d3a89' >> ${.TARGET}
	@echo 'SHA-1 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'761c457bf73b14d27e9e9265c46f4b4dda11f940' >> ${.TARGET}
	@echo 'SHA-1 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'50abf5706a150990a08b2c5ea40fa0e585554732' >> ${.TARGET}

sha256.ref:
	echo 'SHA-256 test suite:' > ${.TARGET}
	@echo 'SHA-256 ("") = e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855' >> ${.TARGET}
	@echo 'SHA-256 ("abc") =' \
		'ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad' >> ${.TARGET}
	@echo 'SHA-256 ("message digest") =' \
		'f7846f55cf23e14eebeab5b4e1550cad5b509e3348fbc4efa3a1413d393cb650' >> ${.TARGET}
	@echo 'SHA-256 ("abcdefghijklmnopqrstuvwxyz") =' \
		'71c480df93d6ae2f1efad1447c66c9525e316218cf51fc8d9ed832f2daf18b73' >> ${.TARGET}
	@echo 'SHA-256 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'db4bfcbd4da0cd85a60c3c37d3fbd8805c77f15fc6b1fdfe614ee0a7c8fdb4c0' >> ${.TARGET}
	@echo 'SHA-256 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'f371bc4a311f2b009eef952dd83ca80e2b60026c8e935592d0f9c308453c813e' >> ${.TARGET}

sha512.ref:
	echo 'SHA-512 test suite:' > ${.TARGET}
	@echo 'SHA-512 ("") =' \
		'cf83e1357eefb8bdf1542850d66d8007d620e4050b5715dc83f4a921d36ce9ce47d0d13c5d85f2b0ff8318d2877eec2f63b931bd47417a81a538327af927da3e' >> ${.TARGET}
	@echo 'SHA-512 ("abc") =' \
		'ddaf35a193617abacc417349ae20413112e6fa4e89a97ea20a9eeee64b55d39a2192992a274fc1a836ba3c23a3feebbd454d4423643ce80e2a9ac94fa54ca49f' >> ${.TARGET}
	@echo 'SHA-512 ("message digest") =' \
		'107dbf389d9e9f71a3a95f6c055b9251bc5268c2be16d6c13492ea45b0199f3309e16455ab1e96118e8a905d5597b72038ddb372a89826046de66687bb420e7c' >> ${.TARGET}
	@echo 'SHA-512 ("abcdefghijklmnopqrstuvwxyz") =' \
		'4dbff86cc2ca1bae1e16468a05cb9881c97f1753bce3619034898faa1aabe429955a1bf8ec483d7421fe3c1646613a59ed5441fb0f321389f77f48a879c7b1f1' >> ${.TARGET}
	@echo 'SHA-512 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'1e07be23c26a86ea37ea810c8ec7809352515a970e9253c26f536cfc7a9996c45c8370583e0a78fa4a90041d71a4ceab7423f19c71b9d5a3e01249f0bebd5894' >> ${.TARGET}
	@echo 'SHA-512 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'72ec1ef1124a45b047e8b7c75a932195135bb61de24ec0d1914042246e0aec3a2354e093d76f3048b456764346900cb130d2a4fd5dd16abb5e30bcb850dee843' >> ${.TARGET}

rmd160.ref:
	echo 'RIPEMD160 test suite:' > ${.TARGET}
	@echo 'RIPEMD160 ("") = 9c1185a5c5e9fc54612808977ee8f548b2258d31' >> ${.TARGET}
	@echo 'RIPEMD160 ("abc") = 8eb208f7e05d987a9b044a8e98c6b087f15a0bfc' >> ${.TARGET}
	@echo 'RIPEMD160 ("message digest") =' \
		'5d0689ef49d2fae572b881b123a85ffa21595f36' >> ${.TARGET}
	@echo 'RIPEMD160 ("abcdefghijklmnopqrstuvwxyz") =' \
		'f71c27109c692c1b56bbdceb5b9d2865b3708dbc' >> ${.TARGET}
	@echo 'RIPEMD160 ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789") =' \
		'b0e20b6e3116640286ed3a87a5713079b21f5189' >> ${.TARGET}
	@echo 'RIPEMD160 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") =' \
		'9b752e45573d4b39f4dbd3323cab82bf63326bfb' >> ${.TARGET}

test:	md4.ref md5.ref sha0.ref rmd160.ref sha1.ref sha256.ref sha512.ref
	@${ECHO} if any of these test fail, the code produces wrong results
	@${ECHO} and should NOT be used.
	${CC} ${CFLAGS} ${LDFLAGS} -DMD=4 -o mddriver ${.CURDIR}/mddriver.c libmd.a
	./mddriver | cmp md4.ref -
	@${ECHO} MD4 passed test
	${CC} ${CFLAGS} ${LDFLAGS} -DMD=5 -o mddriver ${.CURDIR}/mddriver.c libmd.a
	./mddriver | cmp md5.ref -
	@${ECHO} MD5 passed test
	-rm -f mddriver
	${CC} ${CFLAGS} ${LDFLAGS} -o rmddriver ${.CURDIR}/rmddriver.c libmd.a
	./rmddriver | cmp rmd160.ref -
	@${ECHO} RIPEMD160 passed test
	-rm -f rmddriver
	${CC} ${CFLAGS} ${LDFLAGS} -DSHA=0 -o shadriver ${.CURDIR}/shadriver.c libmd.a
	./shadriver | cmp sha0.ref -
	@${ECHO} SHA-0 passed test
	${CC} ${CFLAGS} ${LDFLAGS} -DSHA=1 -o shadriver ${.CURDIR}/shadriver.c libmd.a
	./shadriver | cmp sha1.ref -
	@${ECHO} SHA-1 passed test
	${CC} ${CFLAGS} ${LDFLAGS} -DSHA=256 -o shadriver ${.CURDIR}/shadriver.c libmd.a
	./shadriver | cmp sha256.ref -
	@${ECHO} SHA-256 passed test
	${CC} ${CFLAGS} ${LDFLAGS} -DSHA=512 -o shadriver ${.CURDIR}/shadriver.c libmd.a
	./shadriver | cmp sha512.ref -
	@${ECHO} SHA-512 passed test
	-rm -f shadriver

.include <bsd.lib.mk>

=== cddl/lib/libavl/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libavl/Makefile 204597 2010-03-02 19:04:07Z uqs $

.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/avl

LIB=	avl
SRCS=	avl.c
WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common

.include <bsd.lib.mk>

=== cddl/lib/libnvpair/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libnvpair/Makefile 236884 2012-06-11 11:35:22Z mm $

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libnvpair
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/nvpair

LIB=	nvpair

SRCS=	libnvpair.c \
	nvpair_alloc_system.c \
	nvpair_alloc_fixed.c \
	nvpair.c \
	fnvpair.c

WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem

.include <bsd.lib.mk>

=== cddl/lib/libumem/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libumem/Makefile 204597 2010-03-02 19:04:07Z uqs $

.PATH: ${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem

LIB=	umem
SRCS=	umem.c
WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem

.include <bsd.lib.mk>

=== cddl/lib/libuutil/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libuutil/Makefile 204597 2010-03-02 19:04:07Z uqs $

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/avl

LIB=	uutil
SRCS=	avl.c \
	uu_alloc.c \
	uu_avl.c \
	uu_dprintf.c \
	uu_ident.c \
	uu_list.c \
	uu_misc.c \
	uu_open.c \
	uu_pname.c \
	uu_strtoint.c

WARNS?=	0
CFLAGS+= -DNATIVE_BUILD
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head

.include <bsd.lib.mk>

=== cddl/lib/libzfs/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libzfs/Makefile 266758 2014-05-27 18:22:52Z delphij $

.PATH: ${.CURDIR}/../../../cddl/compat/opensolaris/misc
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common

LIB=	zfs
DPADD=	${LIBMD} ${LIBPTHREAD} ${LIBUMEM} ${LIBUTIL} ${LIBM} ${LIBNVPAIR} \
	${LIBAVL} ${LIBZFS_CORE}
LDADD=	-lmd -lpthread -lumem -lutil -lm -lnvpair -lavl -lzfs_core

SRCS=	deviceid.c \
	fsshare.c \
	mkdirp.c \
	mnttab.c \
	thread_pool.c \
	zmount.c \
	zone.c

SRCS+=	libzfs_changelist.c \
	libzfs_compat.c \
	libzfs_config.c \
	libzfs_dataset.c \
	libzfs_diff.c \
	libzfs_import.c \
	libzfs_iter.c \
	libzfs_mount.c \
	libzfs_pool.c \
	libzfs_sendrecv.c \
	libzfs_status.c \
	libzfs_util.c \
	zfeature_common.c \
	zfs_comutil.c \
	zfs_deleg.c \
	zfs_fletcher.c \
	zfs_ioctl_compat.c \
	zfs_namecheck.c \
	zfs_prop.c \
	zpool_prop.c \
	zprop_common.c \

WARNS?=	0
CSTD=	c99
CFLAGS+= -DZFS_NO_ACL
CFLAGS+= -I${.CURDIR}/../../../sbin/mount
CFLAGS+= -I${.CURDIR}/../../../cddl/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs_core/common

.include <bsd.lib.mk>

=== cddl/lib/libzfs_core/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libzfs_core/Makefile 248461 2013-03-18 09:32:29Z mm $

.PATH: ${.CURDIR}/../../../cddl/compat/opensolaris/misc
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs_core/common
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common

LIB=	zfs_core
DPADD=	${LIBNVPAIR}
LDADD=	-lnvpair

SRCS=	libzfs_core.c \
	libzfs_core_compat.c

SRCS+=	libzfs_compat.c

WARNS?=	0
CSTD=	c99
CFLAGS+= -DZFS_NO_ACL
CFLAGS+= -I${.CURDIR}/../../../sbin/mount
CFLAGS+= -I${.CURDIR}/../../../cddl/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs_core/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common

.include <bsd.lib.mk>

=== cddl/lib/libzpool/Makefile ===
# $FreeBSD: releng/10.1/cddl/lib/libzpool/Makefile 254949 2013-08-27 04:01:31Z will $

.include "${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/Makefile.files"

# ZFS_COMMON_SRCS
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
# ZFS_SHARED_SRCS
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
# KERNEL_SRCS
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
# LIST_SRCS
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/os
# ATOMIC_SRCS
.if exists(${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/atomic/${MACHINE_ARCH}/opensolaris_atomic.S)
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/atomic/${MACHINE_ARCH}
ATOMIC_SRCS=	opensolaris_atomic.S
.if ${MACHINE_ARCH} != "ia64" && ${MACHINE_ARCH} != "sparc64"
ACFLAGS+=	-Wa,--noexecstack
.endif
.else
.PATH: ${.CURDIR}/../../../sys/cddl/compat/opensolaris/kern
ATOMIC_SRCS=	opensolaris_atomic.c
.endif
# UNICODE_SRCS
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/unicode

LIB=		zpool

ZFS_COMMON_SRCS= ${ZFS_COMMON_OBJS:C/.o$/.c/} vdev_file.c trim_map.c
ZFS_SHARED_SRCS= ${ZFS_SHARED_OBJS:C/.o$/.c/}
KERNEL_SRCS=	kernel.c taskq.c util.c
LIST_SRCS=	list.c
UNICODE_SRCS=	u8_textprep.c

SRCS=		${ZFS_COMMON_SRCS} ${ZFS_SHARED_SRCS} \
		${KERNEL_SRCS} ${LIST_SRCS} ${ATOMIC_SRCS} \
		${UNICODE_SRCS}

WARNS?=		0
CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+=	-I${.CURDIR}/../../compat/opensolaris/include
CFLAGS+=	-I${.CURDIR}/../../compat/opensolaris/lib/libumem
CFLAGS+=	-I${.CURDIR}/../../contrib/opensolaris/lib/libzpool/common
CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+=	-I${.CURDIR}/../../contrib/opensolaris/head
CFLAGS+=	-I${.CURDIR}/../../lib/libumem
CFLAGS+=	-I${.CURDIR}/../../contrib/opensolaris/lib/libnvpair
# XXX: pthread doesn't have mutex_owned() equivalent, so we need to look
#      into libthr private structures. That's sooo evil, but it's only for
#      ZFS debugging tools needs.
CFLAGS+=	-DWANTS_MUTEX_OWNED
CFLAGS+=	-I${.CURDIR}/../../../lib/libpthread/thread
CFLAGS+=	-I${.CURDIR}/../../../lib/libpthread/sys
CFLAGS+=	-I${.CURDIR}/../../../lib/libthr/arch/${MACHINE_CPUARCH}/include

DPADD=		${LIBMD} ${LIBPTHREAD} ${LIBZ}
LDADD=		-lmd -lpthread -lz

# atomic.S doesn't like profiling.
NO_PROFILE=

CSTD=	c99

# Since there are many asserts in this library, it makes no sense to compile
# it without debugging.

CFLAGS+=	-g -DDEBUG=1

.include <bsd.lib.mk>

=== cddl/sbin/zfs/Makefile ===
# $FreeBSD: releng/10.1/cddl/sbin/zfs/Makefile 248571 2013-03-21 08:38:03Z mm $

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/cmd/zfs

PROG=	zfs
MAN=	zfs.8
SRCS=	zfs_main.c zfs_iter.c

WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs_core/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libumem/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs

DPADD=	${LIBGEOM} ${LIBJAIL} ${LIBNVPAIR} ${LIBUMEM} \
	${LIBUTIL} ${LIBUUTIL} ${LIBZFS_CORE} ${LIBZFS}
LDADD=	-lgeom -ljail -lnvpair -lumem -lutil -luutil -lzfs_core -lzfs

.include <bsd.prog.mk>

=== cddl/sbin/zpool/Makefile ===
# $FreeBSD: releng/10.1/cddl/sbin/zpool/Makefile 268649 2014-07-15 04:53:34Z delphij $

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/cmd/zpool
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/cmd/stat/common
.PATH: ${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs

PROG=	zpool
MAN=	zpool.8 zpool-features.7
SRCS=	zpool_main.c zpool_vdev.c zpool_iter.c zpool_util.c zfs_comutil.c
SRCS+=	timestamp.c

WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../../cddl/compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libuutil/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libumem/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzfs_core/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../../cddl/contrib/opensolaris/cmd/stat/common

DPADD=	${LIBAVL} ${LIBGEOM} ${LIBNVPAIR} \
	${LIBUMEM} ${LIBUTIL} ${LIBUUTIL} ${LIBZFS_CORE} ${LIBZFS}
LDADD=	-lavl -lgeom -lnvpair -lumem -lutil -luutil -lzfs_core -lzfs

.include <bsd.prog.mk>

=== cddl/usr.bin/zinject/Makefile ===
# $FreeBSD: releng/10.1/cddl/usr.bin/zinject/Makefile 268649 2014-07-15 04:53:34Z delphij $

.PATH: ${.CURDIR}/../../contrib/opensolaris/cmd/zinject

PROG=	zinject
SRCS=	zinject.c translate.c
NO_MAN=

WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libzfs/common
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libzfs_core/common
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs/
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../lib/libumem

DPADD=	${LIBGEOM} ${LIBM} ${LIBNVPAIR} ${LIBUMEM} ${LIBUUTIL} \
	${LIBZFS_CORE} ${LIBZFS} ${LIBZPOOL}
LDADD=	-lgeom -lm -lnvpair -lumem -luutil -lzfs_core -lzfs -lzpool

.include <bsd.prog.mk>

=== cddl/usr.bin/ztest/Makefile ===
# $FreeBSD: releng/10.1/cddl/usr.bin/ztest/Makefile 254949 2013-08-27 04:01:31Z will $

.PATH: ${.CURDIR}/../..//contrib/opensolaris/cmd/ztest

PROG=	ztest
NO_MAN=

WARNS?=	0
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/compat/opensolaris
CFLAGS+= -I${.CURDIR}/../../compat/opensolaris/include
CFLAGS+= -I${.CURDIR}/../../compat/opensolaris/lib/libumem
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libzpool/common
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/lib/libnvpair
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/fs/zfs
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common/sys
CFLAGS+= -I${.CURDIR}/../../../sys/cddl/contrib/opensolaris/uts/common
CFLAGS+= -I${.CURDIR}/../../contrib/opensolaris/head
CFLAGS+= -I${.CURDIR}/../../lib/libumem

DPADD=	${LIBGEOM} ${LIBM} ${LIBNVPAIR} ${LIBUMEM} ${LIBZPOOL} \
	${LIBPTHREAD} ${LIBAVL} ${LIBZFS_CORE} ${LIBZFS} ${LIBUUTIL}
LDADD=	-lgeom -lm -lnvpair -lumem -lzpool -lpthread -lavl -lzfs_core -lzfs \
	-luutil

CSTD=	c99

# Since there are many asserts in this program, it makes no sense to compile
# it without debugging.
CFLAGS+= -g -DDEBUG=1

.include <bsd.prog.mk>

=== debian/changelog ===
zfsutils (10.1~svn272500-1) unstable; urgency=low

  [ Petr Salinger ]
  * New upstream snapshot of 10.1-RC1

  [ Steven Chamberlain ]
  * Add myself to uploaders 

  [ Christoph Egger ]
  * Upload to unstable
  * Force newer kernel headers

 -- Christoph Egger <christoph@debian.org>  Sun, 05 Oct 2014 18:23:36 +0200

zfsutils (10.1~svn271683-2) experimental; urgency=medium

  [ Steven Chamberlain ]
  * bug762199.patch: st_size is only meaningful for regular files;
    existing code did not detect any zpools for import (Closes: #762199)
  * cddl/compat/opensolaris/misc/fsshare.c: don't include missing/unused
    libutil.h;  not needed and caused FTBFS on kfreebsd-i386 only
  * Bump minimum GRUB version to 2.02~beta2-11 for lz4_compress support;
    enabled by default for metadata (but not file contents, yet)
  * Fix display of RAID-Z devices in "zpool status" (Thanks, Jeff Epler!
    Closes: #653929)

 -- Christoph Egger <christoph@debian.org>  Fri, 19 Sep 2014 15:43:47 -0700

zfsutils (10.1~svn271683-1) experimental; urgency=low

  [ Robert Millan ]
  * Library dependency cleanup: Remove gratuitous dependencies, add
    missing dependencies and build libavl as a shared object.
  * Fetch source code securely (https) in get-orig-source.
  * Correctly setup BSD version of MAKEFLAGS to support parallel builds.

  [ Steven Chamberlain ]
  * New upstream snapshot of 10.1-PRERELEASE
    - bump libraries' SONAME to 2
  * Drop patches applied upstream:
    - new upstream has 12_freebsd.diff merged
    - fix_implicit_warnx_declaration.diff
    - zfs_needs_libjail.diff
  * Refresh patches:
    - compat_opensolaris.diff
    - gratuitous_dependencies.diff
    - 14_bootloader_advice.diff
    - solaris_rlim64_t.diff
    - 15_pthread_compat.diff
    - fix_realpath_abuse.diff
    - makefile.diff
  * Build fixes:
    - missing_includes.diff
    - match_glibc_idtype.diff
  * Depend on systemtap-sdt-dev;  it provides an adequate sys/sdt.h
    to build the package although DTrace or SystemTap are unused yet

 -- Christoph Egger <christoph@debian.org>  Wed, 17 Sep 2014 09:50:04 -0700

zfsutils (9.2-4) unstable; urgency=critical

  * Make 14_bootloader_advice.diff more pallatable to upstream.
  * Bump GRUB requirement to 2.00-21 for ZFS v5000 support. (Closes: #730143)

 -- Robert Millan <rmh@debian.org>  Thu, 21 Nov 2013 23:22:43 +0100

zfsutils (9.2-3) unstable; urgency=high

  * Lump cddl/compat/opensolaris patches together into a single patch.
  * Add libzfs_core to zfsutils-udeb.

 -- Robert Millan <rmh@debian.org>  Wed, 20 Nov 2013 14:33:51 +0100

zfsutils (9.2-2) unstable; urgency=low

  * Disable dependency on libjail (by means of MK_JAIL knob, see
    disable_libjail.diff).  (Closes: #725643)

 -- Robert Millan <rmh@debian.org>  Mon, 07 Oct 2013 14:49:03 +0200

zfsutils (9.2-1) unstable; urgency=low

  * New upstream release.
    - Refresh all patches.
    - Update library dependencies.
    - Add new library: libzfs_core.
    - New patches (zfs_needs_libjail.diff, assfail_protection.diff) pending
      merge in upstream.
    - Add libjail-dev to B-D.

  [ Robert Millan ]
  * Build with -Werror=implicit-function-declaration.
    - Requires freebsd-glue >= 0.1.1.
    - fix_implicit_warnx_declaration.diff: Cherry-pick from HEAD.
    - 03_glibc_namespace.diff: Extend solaris_hasmntopt kludge.
  * Remove some unneeded compatibility cruft.

 -- Robert Millan <rmh@debian.org>  Thu, 03 Oct 2013 01:49:26 +0200

zfsutils (9.1-2) unstable; urgency=low

  * Reupload.

 -- Robert Millan <rmh@debian.org>  Mon, 22 Jul 2013 20:14:07 +0200

zfsutils (9.1-1) experimental; urgency=low

  [ Guillem Jover ]
  * Switch to canonical Vcs URLs.

  [ Robert Millan ]
  * New upstream release.
  * control: s/OpenSolaris/illumos/

 -- Robert Millan <rmh@debian.org>  Tue, 16 Jul 2013 13:27:18 +0200

zfsutils (9.0-3) unstable; urgency=low

  * Apply patch supplied by Steven Chamberlain to fix "FTBFS with
    libbsd-dev >= 0.4.0" (Closes: #678136)
  * Update my maintainer address
  * Remove DMUA flag - it's not needed anymore
  * Push standards version without changes

 -- Arno Töll <arno@debian.org>  Fri, 22 Jun 2012 21:28:36 +0200

zfsutils (9.0-2) unstable; urgency=low

  * Remove gratuitous build-dependency on libsbuf-dev (see upstream rev
    226940).
  * Set PATH in weekly scrub crontab.  (Closes: #662140)

 -- Robert Millan <rmh@debian.org>  Mon, 07 May 2012 23:55:36 +0200

=== debian/control ===
Source: zfsutils
Section: admin
Priority: optional
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders:
 Aurelien Jarno <aurel32@debian.org>,
 Robert Millan <rmh@debian.org>,
 Arno Töll <arno@debian.org>,
 Steven Chamberlain <steven@pyro.eu.org>,
Build-Depends: debhelper (>= 7.0.50~),
 freebsd-buildutils (>= 9.0-5~),
 libbsd-dev (>= 0.3.0),
 libc0.1-dev (>= 2.10),
 kfreebsd-kernel-headers (>= 10.1~4~),
 libgeom-dev,
 zlib1g-dev,
 freebsd-glue (>= 0.1.8~),
 systemtap-sdt-dev
Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/zfsutils/
Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/zfsutils/
Standards-Version: 3.9.3

Package: libuutil2
Section: libs
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos userland utility library
 This package contains the illumos userland utility library.

Package: libuutil2-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos userland utility library (debian-installer version)
 This package contains the illumos userland utility library.
 .
 This is a minimal package for use in debian-installer.

Package: libnvpair2
Section: libs
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos name-value pair library
 This package contains the illumos libnvpair library, for managing
 name-value pairs.

Package: libnvpair2-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos name-value pair library (debian-installer version)
 This package contains the illumos libnvpair library, for managing
 name-value pairs.
 .
 This is a minimal package for use in debian-installer.

Package: libzfs2
Section: libs
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos ZFS library
 The Z file system is a pooled filesystem designed for maximum data integrity,
 supporting data snapshots, multiple copies, and data checksums.
 .
 The ZFS library provides support for managing ZFS filesystems.

Package: libzfs2-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos ZFS library (debian-installer version)
 The Z file system is a pooled filesystem designed for maximum data integrity,
 supporting data snapshots, multiple copies, and data checksums.
 .
 The ZFS library provides support for managing ZFS filesystems.
 .
 This is a minimal package for use in debian-installer.

Package: zfsutils
Architecture: kfreebsd-any
# We really need to declare those dependencies manually. Upstream adds happily symbols
# without providing any version informations for symbols or bumping SONAMES Since those libraries are
# supposed to used within this source package only, we declare a hard dependency to come
# over problems like #645305.
# dpkg-shlibdeps can't help us here, because it only can create unversioned
# dependencies.
Depends: ${shlibs:Depends}, ${misc:Depends},
 libuutil2 (= ${binary:Version}), libnvpair2 (= ${binary:Version}),
 libzfs2 (= ${binary:Version}), libumem2 (= ${binary:Version}), libzpool2 (= ${binary:Version})
Recommends: cron
Breaks:
# Require GRUB with ZFS v5000 (feature flags) support and the
# lz4_compress feature, if a newly-created or manually upgraded
# pool is to be bootable
 grub-common (<< 2.02~beta2-11~),
# Pre-28 versions are ABI-incompatible
 kfreebsd-image-8.1-1-amd64,
 kfreebsd-image-8.1-1-486,
 kfreebsd-image-8.1-1-686,
 kfreebsd-image-8.1-1-686-smp,
 kfreebsd-image-8.1-1-xen,
 kfreebsd-image-8.2-1-amd64,
 kfreebsd-image-8.2-1-486,
 kfreebsd-image-8.2-1-686,
 kfreebsd-image-8.2-1-686-smp,
 kfreebsd-image-8.2-1-xen,
Description: command-line tools to manage ZFS filesystems
 The Z file system is a pooled filesystem designed for maximum data integrity,
 supporting data snapshots, multiple copies, and data checksums.
 .
 This package provides the zfs and zpool commands to create and administer
 ZFS filesystems.

Package: zfsutils-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libuutil2-udeb (= ${binary:Version}), libnvpair2-udeb (= ${binary:Version}),
 libzfs2-udeb (= ${binary:Version}), libumem2-udeb (= ${binary:Version}), libzpool2-udeb (= ${binary:Version}),
 zfs-modules,
Description: command-line tools to manage ZFS filesystems (debian-installer version)
 The Z file system is a pooled filesystem designed for maximum data integrity,
 supporting data snapshots, multiple copies, and data checksums.
 .
 This package provides the zfs and zpool commands to create and administer
 ZFS filesystems.
 .
 This is a minimal package for use in debian-installer.


Package: libumem2
Section: libs
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos memory-management library
 This package contains the illumos libumem library, to detect
 memory management bugs in applications

Package: libumem2-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos memory-management library (debian-installer version)
 This package contains the illumos libumem library, to detect
 memory management bugs in applications
 .
 This is a minimal package for use in debian-installer.

Package: libzpool2
Section: libs
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos interface library to manage ZFS storage pools
 This package contains the illumos libzpool library.

Package: libzpool2-udeb
Package-Type: udeb
Section: debian-installer
Architecture: kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: illumos interface library to manage ZFS storage pools (debian-installer version)
 This package contains the illumos libzpool library.
 .
 This is a minimal package for use in debian-installer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
SHELL=bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

CFLAGS = -Wall -Wno-unknown-pragmas -g -pipe -fPIC -I. \
         -D_GNU_SOURCE -DNEED_SOLARIS_BOOLEAN \
	-isystem /usr/include/freebsd \
	-Werror=implicit-function-declaration \
	$(NULL)

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

	# Do not mess with MAKEFLAGS until we transfer control to BSD make (see below)
	BSD_MAKEFLAGS += -j$(NUMJOBS)
endif

full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
tar_version	:= $(shell echo $(full_version) | sed -e 's/-.*//g')
svn_revision	:= $(shell echo $(full_version) | sed -e 's/.*~svn\([0-9]*\)-[0-9]*/\1/g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')
revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')

#SVN		:= https://svn0.us-west.freebsd.org/base/release/$(version).0
SVN		:= https://svn0.us-west.freebsd.org/base/releng/$(version)
#SVN		:= https://svn0.us-west.freebsd.org/base/stable/$(major)
#SVN		:= https://svn0.us-west.freebsd.org/base/head

SOURCE = zfsutils
ORIGDIR = $(SOURCE)-$(tar_version)
TARNAME = $(SOURCE)_$(tar_version).orig.tar.gz

PATH := /usr/lib/freebsd:$(PATH)
DESTDIR = $(CURDIR)/debian/tmp
PMAKE = \
	MAKEFLAGS=$(BSD_MAKEFLAGS) \
	COPTS="$(CFLAGS)" CFLAGS="$(CFLAGS)" NO_WERROR=1 NOGCCERROR=1 \
        NOSHARED=NO NO_SHARED=NO DESTDIR=$(DESTDIR) make
export SHLIB_MAJOR = 2
export SHLIBDIR = ./

get-orig-source:
	rm -rf $(ORIGDIR)
	for i in \
	         cddl/compat/opensolaris \
	         cddl/contrib/opensolaris/head \
	         cddl/contrib/opensolaris/cmd/zdb \
	         cddl/contrib/opensolaris/cmd/zfs \
	         cddl/contrib/opensolaris/cmd/zinject \
	         cddl/contrib/opensolaris/cmd/zpool \
	         cddl/contrib/opensolaris/cmd/ztest \
	         cddl/contrib/opensolaris/lib/libnvpair \
	         cddl/contrib/opensolaris/lib/libuutil \
	         cddl/contrib/opensolaris/lib/libzfs \
		cddl/contrib/opensolaris/lib/libzfs_core \
	         cddl/contrib/opensolaris/lib/libzpool \
		 cddl/contrib/opensolaris/cmd/stat/common/ \
	         sys/cddl/compat/opensolaris \
	         sys/cddl/contrib/opensolaris \
		lib/libmd \
	         cddl/lib/libavl \
	         cddl/lib/libnvpair \
	         cddl/lib/libuutil \
	         cddl/lib/libzpool \
	         cddl/lib/libumem \
	         cddl/lib/libzfs \
		cddl/lib/libzfs_core \
	         cddl/sbin/zpool \
	         cddl/sbin/zfs \
	         cddl/usr.bin/zinject \
	         cddl/usr.bin/ztest \
	         cddl/usr.sbin/zdb \
	         ; do \
	    svn export -r $(svn_revision) $(SVN)/$$i $(ORIGDIR)/$$i ; \
	done
	tar --numeric-owner --owner 0 --group 0 -czf ../$(TARNAME) $(ORIGDIR)
	rm -rf $(ORIGDIR)

build: build-arch build-indep

build-arch: build-libmd build-libuutil build-libnvpair build-libzfs build-libumem build-libzpool build-zfsutils build-libavl

build-indep:
# We have nothing to do by default.


build-libuutil: build-libuutil-stamp
build-libuutil-stamp:
	$(PMAKE) -C $(CURDIR)/cddl/lib/libuutil
	touch $@

build-libnvpair: build-libnvpair-stamp
build-libnvpair-stamp:
	$(PMAKE) -C $(CURDIR)/cddl/lib/libnvpair
	touch $@

build-libumem: build-libumem-stamp
build-libumem-stamp:
	$(PMAKE) -C $(CURDIR)/cddl/lib/libumem
	touch $@


build-libzpool: build-libzpool-stamp
build-libzpool-stamp: build-libavl build-libnvpair-stamp build-libumem build-libmd
	$(PMAKE) -C $(CURDIR)/cddl/lib/libzpool
	touch $@

build-libzfs: build-libzfs-stamp
build-libzfs-stamp: \
		build-libavl \
		build-libnvpair \
		build-libumem \
		build-libuutil \
		build-libzfs_core
	$(PMAKE) -C $(CURDIR)/cddl/lib/libzfs
	touch $@

build-libzfs_core: build-libzfs_core-stamp
build-libzfs_core-stamp: build-libnvpair
	$(PMAKE) -C $(CURDIR)/cddl/lib/libzfs_core
	touch $@

build-libmd: build-libmd-stamp
build-libmd-stamp:
	$(PMAKE) -C $(CURDIR)/lib/libmd
	touch $@

build-libavl: build-libavl-stamp
build-libavl-stamp:
	$(PMAKE) -C $(CURDIR)/cddl/lib/libavl
	touch $@

build-zfsutils: build-zfsutils-stamp
build-zfsutils-stamp: build-libzfs \
		build-libzfs_core \
		build-libnvpair-stamp build-libuutil-stamp build-libumem build-libzpool
	$(PMAKE) -C $(CURDIR)/cddl/sbin/zpool
	$(PMAKE) -C $(CURDIR)/cddl/sbin/zfs -DWITHOUT_JAIL

	$(PMAKE) -C $(CURDIR)/cddl/usr.sbin/zdb
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/zinject
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ztest/
	touch $@

clean:
	dh_testdir
	dh_testroot
	$(PMAKE) -C $(CURDIR)/cddl/lib/libnvpair clean

	$(PMAKE) -C $(CURDIR)/cddl/lib/libuutil clean

	$(PMAKE) -C $(CURDIR)/cddl/lib/libzfs clean
	$(PMAKE) -C $(CURDIR)/cddl/lib/libzfs_core clean

	$(PMAKE) -C $(CURDIR)/cddl/sbin/zpool clean
	$(PMAKE) -C $(CURDIR)/cddl/sbin/zfs clean

	$(PMAKE) -C $(CURDIR)/cddl/lib/libumem clean
	$(PMAKE) -C $(CURDIR)/cddl/lib/libzpool clean
	$(PMAKE) -C $(CURDIR)/cddl/lib/libavl clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.sbin/zdb clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ztest clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/zinject clean
	$(PMAKE) -C $(CURDIR)/lib/libmd clean

	rm -f *stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep -s
	dh_installdirs -s
	dh_install -s


binary: binary-arch binary-indep

binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
#	dh_installexamples
	dh_installinit --no-restart-on-upgrade --name=zfs -- start 26 S . stop 50 0 6 .
	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_perl
#	dh_python
	dh_makeshlibs -a
	dh_makeshlibs -plibnvpair$(SHLIB_MAJOR) --add-udeb=libnvpair$(SHLIB_MAJOR)-udeb
	dh_makeshlibs -plibuutil$(SHLIB_MAJOR) --add-udeb=libuutil$(SHLIB_MAJOR)-udeb
	dh_makeshlibs -plibzfs$(SHLIB_MAJOR) --add-udeb=libzfs$(SHLIB_MAJOR)-udeb
	dh_makeshlibs -plibzpool$(SHLIB_MAJOR) --add-udeb=libzpool$(SHLIB_MAJOR)-udeb
	dh_makeshlibs -plibumem$(SHLIB_MAJOR) --add-udeb=libumem$(SHLIB_MAJOR)-udeb
	dh_makeshlibs -pzfsutils --add-udeb=zfsutils-udeb
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: build clean binary-indep binary-arch binary install configure build-arch build-indep
